#include <stdio.h>
#include <unistd.h>
#include <usb.h>
#include <ftdi.h>

/*
ftdi_open_results[0] = "all fine";
ftdi_open_results[1] = "usb_find_busses() failed";
ftdi_open_results[2] = "usb_find_devices() failed";
ftdi_open_results[3] = "usb device not found";
ftdi_open_results[4] = "unable to open device";
ftdi_open_results[5] = "unable to claim device";
ftdi_open_results[6] = "reset failed";
ftdi_open_results[7] = "set baudrate failed";
*/


int show_ftdic(struct ftdi_context ftdic)
{
   printf("Display struct\n");
   printf("Type : %d\n", ftdic.type);
   printf("Interface : %d\n", ftdic.interface);
   printf("Index : %d\n", ftdic.index);
   printf("Out_ep : 0x%2x In_ep : 0x%2x \n", ftdic.out_ep,  ftdic.in_ep);
   return 0;
}


int main(int argc, char **argv)
{
  struct ftdi_context ftdic,ftdic2;
  int f,i;
  unsigned char pins;

  ftdi_init(&ftdic);

  show_ftdic(ftdic);

  f = ftdi_usb_open(&ftdic, 0x0403, 0x6010);

  if(f < 0 && f != -5) {
    fprintf(stderr, "unable to open ftdi device: %d\n",f);
    exit(-1);
  }

  printf("ftdi open succeeded: %d\n",f);
  show_ftdic(ftdic);
  
  printf("enabling bitbang mode\n");
  ftdi_enable_bitbang(&ftdic, 0x0F);



  ftdic2.interface=1;
  ftdic2.index=1;
  ftdic2.out_ep=0x83;
  ftdic2.in_ep=0x4;

  f = ftdi_usb_open(&ftdic2, 0x0403, 0x6010);

  if(f < 0 && f != -5) {
    fprintf(stderr, "unable to open ftdi device: %d\n",f);
    exit(-1);
  }

  printf("ftdi 2open succeeded: %d\n",f);
  show_ftdic(ftdic2);

  printf("enabling bitbang mode\n");
  ftdi_enable_bitbang(&ftdic2, 0xFF);


  char buf[1];

  pins=0;
  f=ftdi_read_pins(&ftdic, &pins);
  printf("Read: 0x%02x (return: %d)\n", pins, f);

  sleep(2);

  buf[0] = 0x0;
  printf("turning everything on\n");
  f = ftdi_write_data(&ftdic, buf, 1);
  if(f < 0) {
    fprintf(stderr,"write failed for 0x%x, error %d\n",buf[0],f);
  }

  pins=0;
  f=ftdi_read_pins(&ftdic, &pins);
  printf("Read: 0x%02x (return: %d)\n", pins, f);

  sleep(2);

  buf[0] = 0x0F;
  printf("turning everything off\n");
  f = ftdi_write_data(&ftdic, buf, 1);
  if(f < 0) {
    fprintf(stderr,"write failed for 0x%x, error %d\n",buf[0],f);
  }

  sleep(2);

  pins=0;
  f=ftdi_read_pins(&ftdic, &pins);
  printf("Read: 0x%02x (return: %d)\n", pins, f);


  for(i = 0; i < 21; i++) {
    buf[0] =  (0x1 & (i%2));
    buf[0] |= (0x2 & (i%3));
    printf("%d 0x%02hhx ",i, buf[0]);
    fflush(stdout);
    f = ftdi_write_data(&ftdic, buf, 1);
    if(f < 0) {
      fprintf(stderr,"write failed for 0x%x, error %d\n",buf[0],f);
    }
    sleep(1);
    pins=0;
    f=ftdi_read_pins(&ftdic, &pins);
    printf("Read 1: 0x%02x (return: %d)\n", pins, f);
 //   pins=0;
 //   f=ftdi_read_data(&ftdic, &pins, 1);
 //   printf("Read 2: 0x%02x (return: %d)\n", pins, f);

  }

  printf("\n");
  
  printf("disabling bitbang mode\n");
  ftdi_disable_bitbang(&ftdic);

  ftdi_usb_close(&ftdic);
  ftdi_deinit(&ftdic);
}
