#ifndef _LZMALIB_H
#define _LZMALIB_H
#include "LzmaDecode.h"

#define LZMA_OK 0
#define LZMA_STREAM_END 1
#define LZMA_DECODE_ERROR 2


 typedef struct _CBuffer
 {
    ILzmaInCallback InCallback;
    unsigned char *Buffer;
    unsigned int Size;
    unsigned int eof;
    void *fpe;
    int (*lzread)(void *, void *,int);
 } CBuffer;

 typedef struct lzmastream {
    unsigned int processedSize;
    unsigned int dictionarySize;
    unsigned int compressedSize;
    unsigned int outSize;
    unsigned int outSizeProcessed;
    unsigned int lzmaInternalSize;
    unsigned int avail_out;
    unsigned int ReadBlockSize;
    int          lc,lp,pb;    
    unsigned char *dictionary;
    unsigned char properties[5];
    unsigned char *lzmaInternalData;
    unsigned char *insteam;
    unsigned char *outStream;
    CBuffer       bo;
    void *(*malloc) (unsigned long);
    void (*free) (void *);
    
 } lz_stream;

static int Lzma_fill_in_properties(lz_stream *lz);
int LzmaInit(lz_stream *lz);
int LzmaDecompress(lz_stream *lz);
void LzmaDecompressEnd(lz_stream *lz);
int LzmaReadCompressed(void *object, unsigned char **buffer, unsigned int *size);
#endif 
